##################################################
#
# go backend build
FROM openshift/golang-builder:1.12 AS gobuilder
ENV __doozer=update BUILD_RELEASE=202006211650.p0 BUILD_VERSION=v4.3.27 OS_GIT_MAJOR=4 OS_GIT_MINOR=3 OS_GIT_PATCH=27 OS_GIT_TREE_STATE=clean OS_GIT_VERSION=4.3.27-202006211650.p? 
ENV __doozer=merge OS_GIT_COMMIT=a7eba36 OS_GIT_VERSION=4.3.27-202006211650.p?-a7eba36 SOURCE_DATE_EPOCH=1591957051 SOURCE_GIT_COMMIT=a7eba368afdef722d420fba483d943b57f514f6e SOURCE_GIT_TAG=v6.0.6-6877-ga7eba368a SOURCE_GIT_URL=https://github.com/openshift/console 
RUN mkdir -p /go/src/github.com/openshift/console/
ADD . /go/src/github.com/openshift/console/
WORKDIR /go/src/github.com/openshift/console/
RUN ./build-backend.sh


##################################################
#
# nodejs frontend build
FROM rhscl/nodejs-8-rhel7:1 AS nodebuilder
ENV __doozer=update BUILD_RELEASE=202006211650.p0 BUILD_VERSION=v4.3.27 OS_GIT_MAJOR=4 OS_GIT_MINOR=3 OS_GIT_PATCH=27 OS_GIT_TREE_STATE=clean OS_GIT_VERSION=4.3.27-202006211650.p? 
ENV __doozer=merge OS_GIT_COMMIT=a7eba36 OS_GIT_VERSION=4.3.27-202006211650.p?-a7eba36 SOURCE_DATE_EPOCH=1591957051 SOURCE_GIT_COMMIT=a7eba368afdef722d420fba483d943b57f514f6e SOURCE_GIT_TAG=v6.0.6-6877-ga7eba368a SOURCE_GIT_URL=https://github.com/openshift/console 

ADD . .

USER 0
# extract the yarn dependencies that must be provided in the dist-git lookaside cache
RUN tar fx yarn-offline.tar

# bootstrap yarn so we can install and run the other tools.
RUN container-entrypoint npm install ./yarn-1.9.4.tgz

# prevent download of chromedriver, sass binary, and node headers as part of module installs
ENV CHROMEDRIVER_SKIP_DOWNLOAD=true \
    SKIP_SASS_BINARY_DOWNLOAD_FOR_CI=true \
    NPM_CONFIG_TARBALL=$HOME/node-v8.9.4-headers.tar.gz

# run the build
RUN container-entrypoint ./build-frontend.sh


##################################################
#
# actual base image for final product
FROM openshift/ose-base:v4.3.27.20200621.173109
ENV __doozer=update BUILD_RELEASE=202006211650.p0 BUILD_VERSION=v4.3.27 OS_GIT_MAJOR=4 OS_GIT_MINOR=3 OS_GIT_PATCH=27 OS_GIT_TREE_STATE=clean OS_GIT_VERSION=4.3.27-202006211650.p? 
ENV __doozer=merge OS_GIT_COMMIT=a7eba36 OS_GIT_VERSION=4.3.27-202006211650.p?-a7eba36 SOURCE_DATE_EPOCH=1591957051 SOURCE_GIT_COMMIT=a7eba368afdef722d420fba483d943b57f514f6e SOURCE_GIT_TAG=v6.0.6-6877-ga7eba368a SOURCE_GIT_URL=https://github.com/openshift/console 
RUN mkdir -p /opt/bridge/bin
COPY --from=gobuilder /go/src/github.com/openshift/console/bin/bridge /opt/bridge/bin
COPY --from=nodebuilder /opt/app-root/src/frontend/public/dist /opt/bridge/static

WORKDIR /
# doesn't require a root user.
USER 1001

CMD [ "/opt/bridge/bin/bridge", "--public-dir=/opt/bridge/static" ]

LABEL \
        io.k8s.description="This is a component of OpenShift Container Platform and provides a web console." \
        com.redhat.component="openshift-enterprise-console-container" \
        maintainer="Samuel Padgett <spadgett@redhat.com>" \
        name="openshift/ose-console" \
        License="GPLv2+" \
        io.k8s.display-name="OpenShift Console" \
        vendor="Red Hat" \
        io.openshift.tags="openshift,console" \
        io.openshift.maintainer.product="OpenShift Container Platform" \
        io.openshift.maintainer.component="Management Console" \
        version="v4.3.27" \
        release="202006211650.p0" \
        io.openshift.build.commit.id="a7eba368afdef722d420fba483d943b57f514f6e" \
        io.openshift.build.source-location="https://github.com/openshift/console" \
        io.openshift.build.commit.url="https://github.com/openshift/console/commit/a7eba368afdef722d420fba483d943b57f514f6e"

